import '../lib/properties.dart';
import 'dart:io';

String path = '/Users/kevin/Documents/workspace/properties-cl-test/resources/sample.properties';
String path2 = '/Users/kevin/Documents/workspace/properties-cl-test/resources/sample-conversion.properties';

void list(List<int> bytes){
for(var i = 0; i < bytes.length; i++){
    
    print("${bytes[i]} (${new String.fromCharCode(bytes[i])})");
    
  }
}

bool contains(List<int> bytes, int c){
  
  
  for(var i = 0; i < bytes.length; i++){
    
    print("${bytes[i]} (${new String.fromCharCode(bytes[i])}) == ${c}");
    
    if(bytes[i] == c){
      return true;
    }
  
  }
  
  return false;
}

List<List<int>> getLines(List<int> bytes){
  List<List<int>> result = [];
  List<int> line = [];
  
  var nl = '\n'.charCodes[0];
  
  for(var i = 0; i < bytes.length; i++){
    
    if(bytes[i] != nl){
      line.add(bytes[i]);
    } else {
      result.add(line);
      line = [];
    }
    
    if(i == bytes.length -1)
      result.add(line);
  
  }
  
  return result;
}

List<List<int>> splitKeyValue(List<int> line){
  
  List<List<int>> result = [];
  List<int> key = [];
  List<int> value = [];
  
  var equal = '='.charCodes[0];
  
  bool isKey = true;
  
  for(var i = 0; i < line.length; i++){
    
    if(line[i] == equal && isKey){
      isKey = false;
    } else {
      if(isKey){
        key.add(line[i]);
      } else {
        value.add(line[i]);
      }
    }
  }
  
  result.add(key);
  result.add(value);
  
  return result;
}

void main() {
  
  Properties p = new Properties.fromFile(path2);
  
  int i = p.getInt("test.key.integer.X", defkey:"test.key.integer");
  
  var file = new File.fromPath(new Path(path));
  List<int> bytes = file.readAsBytesSync();
  
  list(bytes);
  
  print("\n\n");
  
  var slash = r'\'.charCodes[0];
  var nl = '\n'.charCodes[0];
  var eq = '='.charCodes[0];
  
  var result = contains(bytes, nl);
  
  print("contains newline? ${result} \n\n");
  
  result = contains(bytes, slash);
  
  print("contains slash? ${result}");
  
  var lines = getLines(bytes);
  
  print("lines? (${lines.length}) ${lines}");
  
  for(List<int> l in lines)
    print("* ${new String.fromCharCodes(l)}");
  
  for(List<int> line in lines){
    List<List<int>> keyvalue = splitKeyValue(line);
    print("** ${keyvalue}");
  }
}
